local tmp = package.path
package.path = package.path .. ";UAV.rte/?.lua"
require("common")
package.path = tmp

function Create(self)
	UAVInitialize(self)
	
	-- specific for this craft
	self.occlusion = 68
	self.payload = 220
	self.payloadRof = 100	-- time in ms between rounds (100 = 2x600rpm)
end

function Destroy(self)
	UAVDestroy(self)
end

function Update(self)
	self.angle = self.RotAngle
	if self.HFlipped then
		self.angle = self.angle + math.pi
	end
	
	if self.RotAngle > math.pi or self.RotAngle < -math.pi then
		self.RotAngle = 0
		self.HFlipped = not self.HFlipped
	end
	
	-- movement in direction of view angle
	self.speed = math.abs(self.Vel.Magnitude * math.cos(math.abs(self.Vel.AbsRadAngle - self.RotAngle)))
	
	UAVMove(self)
	
	if ToActor(self):IsPlayerControlled() then
		self.playerCtrl = true
		UAVMap(self)
	
		-- specific for this craft
		if self:GetController():IsState(Controller.PRIMARY_ACTION) then
			if self.ammo > 0 then
				UAVFireMG(self)
			end
			
			if self.payload > 0 and self.DropTimer:IsPastSimMS(self.payloadRof) then	-- Fire gun pods
				self.DropTimer:Reset()
				
				local bulletType = "UAV 50 cal"
				if self.payload % 2 == 0 then
					bulletType = "UAV 50 cal Tracer"
				end
				
				local Emitter = CreateAEmitter(bulletType)
				Emitter.Vel = self.Vel
				Emitter.Pos = self.Pos + self:RotateOffset(Vector(math.abs(self.SpriteOffset.X) + 15, 16))
				Emitter.RotAngle = self.angle
				MovableMan:AddParticle(Emitter)
				
				self.payload = self.payload - 1
				if self.payload % 44 == 0 then
					self:AddInventoryItem(CreateHDFirearm(".", "UAV.rte"))	-- Negative Gold
				end
			end
			
			if self.ammo < 1 and self.payload < 1 then
				UAVAddIcon(self, CreateMOSParticle("No Ammo"), 5)
			end
		end
	elseif self.playerCtrl then
		UAVDestroy(self)
	end
end